<?php
defined('APP') or die('Hacking attemp!');
abstract class Core_Controller{
    protected $view;
	protected $settings;
    public function __construct(){
        $this->view = new Core_View();
		$temp = new Core_Model();
		$this->settings = $temp->LoadConfigSite();
    	}
	public function loadModel($name){
		$file = __SITE_PATH . DS .'models'. DS.$name . '.php';
        if(! file_exists($file)) {
            die('Invalid model file : ' . $file);
        	}
		$newname = 'Model_'.ucfirst($name);
		if(class_exists($newname))
			$this->$name = new $newname;
		else die('Class \''.$newname.'\' does not exist!');
		}
	public function IpAddress(){
		if (!empty($_SERVER['HTTP_CLIENT_IP']))   
			$ipAddress=$_SERVER['HTTP_CLIENT_IP'];
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   
			$ipAddress=$_SERVER['HTTP_X_FORWARDED_FOR'];
		else
			$ipAddress=$_SERVER['REMOTE_ADDR'];
		return $ipAddress;
		}
	public function valid_email($address){
		return ( ! preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $address)) ? FALSE : TRUE;
		}
	public function random_string($len=0){
		$pool = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$str = '';
		for ($i=0; $i < $len; ++$i)
			$str .= substr($pool, mt_rand(0, strlen($pool) -1), 1);
		return $str;
		}
	public function Pagination($config=array()){
		$output = '';
		$rs_maxpage = $config['js_numrows_page']>0?ceil($config['js_numrows_page']/$config['per_page']):0;
		$eitherside = ($config['showeachside'] * $config['per_page']);
		$paga = (strpos($config['cururl'], '?')!==false)?'&p=':'?p=';
		if($rs_maxpage>1){
			if($config['rs_start']+1 > $eitherside){
				$page = $config['curpage'] - 1;
				$output .= '<a href="'.$config['cururl'].'"><i>'.$config['firstpage'].'</i></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="'.$config['cururl'].$paga.$page.'"><i><<</i></a> . . . ';
				}
				$pg=1;
			for($y=0; $y<$config['js_numrows_page']; $y+=$config['per_page']){
				if(($y > ($config['rs_start'] - $eitherside)) && ($y < ($config['rs_start'] + $eitherside)))
					$output .= ($pg==$config['curpage'])?'<b> &nbsp;'.$pg.'</b>':' &nbsp;<a href="'.$config['cururl'].$paga.$pg.'">'.$pg.'</a>';
				++$pg;
				}
			if(($config['rs_start']+$eitherside)<$config['js_numrows_page']){
				$page = $config['curpage'] + 1;
				$output .=  ' . . . <a href="'.$config['cururl'].$paga.$page.'"><i>>></i></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="'.$config['cururl'].$paga.$rs_maxpage.'"><i>'.$config['lastpage'].'</i></a>';
				}
			}
		return $output;
		}
	public function chkDateValid($format, $date=''){
		if(!empty($date)){
			switch(strtoupper($format)){
				case 'DD-MM-YYYY':
					$temp = explode('-',$date);
					return checkdate((int)$temp[1], (int)$temp[0], (int)$temp[2] );
				break;
				case 'MM-DD-YYYY':
					$temp = explode('-',$date);
					return checkdate((int)$temp[0], (int)$temp[1], (int)$temp[2] );
				break;
				case 'YYYY-DD-MM':
					$temp = explode('-',$date);
					return checkdate((int)$temp[2], (int)$temp[1], (int)$temp[0] );
				break;
				default: //YYYY-MM-DD
					$temp = explode('-',$date);
					return checkdate((int)$temp[1], (int)$temp[2], (int)$temp[0] );
				break;
				}
			}
		return false;
		}
	public function ThePaging($config=array()){
		$output = '';
		$rs_maxpage = $config['js_numrows_page']>0?ceil($config['js_numrows_page']/$config['per_page']):0;
		$eitherside = ($config['showeachside'] * $config['per_page']);
		$paga = (strpos($config['cururl'], '?')!==false)?'&p=':'?p=';
		if($rs_maxpage>1){
			if($config['rs_start']+1 > $eitherside){
				$page = $config['curpage'] - 1;
				$output .= '<a href="javascript:ThePaging(1)"><i>'.$config['firstpage'].'</i></a>&nbsp;&nbsp;&nbsp;&nbsp;<span style="padding:0px 5px; background:#f2f2f2; color:#424242; cursor:pointer" onclick="ThePaging('.$page.')">&laquo;</span> . . . ';
				}
				$pg=1;
			for($y=0; $y<$config['js_numrows_page']; $y+=$config['per_page']){
				if(($y > ($config['rs_start'] - $eitherside)) && ($y < ($config['rs_start'] + $eitherside)))
					$output .= ($pg==$config['curpage'])?'&nbsp;<span style="padding:0px 5px; background:#1979ca; color:#FFF; font-weight:bold; cursor:default">'.$pg.'</span>':'&nbsp;<span style="padding:0px 5px; background:#f2f2f2; color:#424242; cursor:pointer" onclick="ThePaging('.$pg.')">'.$pg.'</span>';
				++$pg;
				}
			if(($config['rs_start']+$eitherside)<$config['js_numrows_page']){
				$page = $config['curpage'] + 1;
				$output .=  ' . . . <span style="padding:0px 5px; background:#f2f2f2; color:#424242; cursor:pointer" onclick="ThePaging('.$page.')">&raquo;</span>&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:ThePaging('.$rs_maxpage.')"><i>'.$config['lastpage'].'</i></a>';
				}
			}
		return $output;
		}
	}